// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_common_msgs:msg/ServiceHeader.idl
// generated code does not contain a copyright notice
#include "marti_common_msgs/msg/detail/service_header__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `sender`
#include "rosidl_runtime_c/string_functions.h"

bool
marti_common_msgs__msg__ServiceHeader__init(marti_common_msgs__msg__ServiceHeader * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    marti_common_msgs__msg__ServiceHeader__fini(msg);
    return false;
  }
  // sequence
  // sender
  if (!rosidl_runtime_c__String__init(&msg->sender)) {
    marti_common_msgs__msg__ServiceHeader__fini(msg);
    return false;
  }
  // result
  return true;
}

void
marti_common_msgs__msg__ServiceHeader__fini(marti_common_msgs__msg__ServiceHeader * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // sequence
  // sender
  rosidl_runtime_c__String__fini(&msg->sender);
  // result
}

marti_common_msgs__msg__ServiceHeader *
marti_common_msgs__msg__ServiceHeader__create()
{
  marti_common_msgs__msg__ServiceHeader * msg = (marti_common_msgs__msg__ServiceHeader *)malloc(sizeof(marti_common_msgs__msg__ServiceHeader));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_common_msgs__msg__ServiceHeader));
  bool success = marti_common_msgs__msg__ServiceHeader__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_common_msgs__msg__ServiceHeader__destroy(marti_common_msgs__msg__ServiceHeader * msg)
{
  if (msg) {
    marti_common_msgs__msg__ServiceHeader__fini(msg);
  }
  free(msg);
}


bool
marti_common_msgs__msg__ServiceHeader__Sequence__init(marti_common_msgs__msg__ServiceHeader__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_common_msgs__msg__ServiceHeader * data = NULL;
  if (size) {
    data = (marti_common_msgs__msg__ServiceHeader *)calloc(size, sizeof(marti_common_msgs__msg__ServiceHeader));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_common_msgs__msg__ServiceHeader__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_common_msgs__msg__ServiceHeader__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_common_msgs__msg__ServiceHeader__Sequence__fini(marti_common_msgs__msg__ServiceHeader__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_common_msgs__msg__ServiceHeader__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_common_msgs__msg__ServiceHeader__Sequence *
marti_common_msgs__msg__ServiceHeader__Sequence__create(size_t size)
{
  marti_common_msgs__msg__ServiceHeader__Sequence * array = (marti_common_msgs__msg__ServiceHeader__Sequence *)malloc(sizeof(marti_common_msgs__msg__ServiceHeader__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_common_msgs__msg__ServiceHeader__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_common_msgs__msg__ServiceHeader__Sequence__destroy(marti_common_msgs__msg__ServiceHeader__Sequence * array)
{
  if (array) {
    marti_common_msgs__msg__ServiceHeader__Sequence__fini(array);
  }
  free(array);
}
